c = 344;
Rho = 1.2;

Ang = (0:1:90)*pi/180;

R_flow = 550;
% R_flow = 200000;

fcenter = 1000*(2.0).^[-3:4];
fd = (2^0.5);
fupper = fcenter.*fd;
flower = fcenter./fd;
% fcenter = 1:1:5700;

Q = zeros(3,8);

for ii = 1:8%length(fcenter)
    Zeta0 = 1+9.08*(1*fcenter(ii)/R_flow)^-0.75 ...
                    + 1i*11.9*(1*fcenter(ii)/R_flow)^-0.75;

    Zeta1 = 1+5.50*(1*fcenter(ii)/R_flow)^-0.632 ...
                    + 1i*8.43*(1*fcenter(ii)/R_flow)^-0.632;
                
%     Zeta0 = Zn0;
%     Zeta1 = Zn1;

    Alfa0 = (4*real(Zeta0).*cos(Ang)) ./ ((abs(Zeta0).*cos(Ang)).^2 + 2*real(Zeta0).*cos(Ang) + 1);
    Alfa1 = (4*real(Zeta1).*cos(Ang)) ./ ((abs(Zeta1).*cos(Ang)).^2 + 2*real(Zeta1).*cos(Ang) + 1);
    
    plot(0:1:90,Alfa0,'b')
    hold on
    plot(0:1:90,Alfa1,'r')

    Zeta2 = 1+0.00027*((2 - log10(fcenter(ii)/(R_flow*1000)))^6.2) ...
                - 1i*0.0047*((2 - log10(fcenter(ii)/(R_flow*1000)))^4.1);
    Zeta = Zeta2;        
            
    Alfa2 = (4*real(Zeta).*cos(Ang)) ./ ((abs(Zeta).*cos(Ang)).^2 + 2*real(Zeta).*cos(Ang) + 1);
    
    plot(0:1:90,Alfa2,'k')
%   hold off
    
    fun = @(Ang) (4*real(Zeta).*cos(Ang)) ./ ((abs(Zeta).*cos(Ang)).^2 + 2*real(Zeta).*cos(Ang) + 1).*sin(2*Ang);

    q = integral(fun, 0, pi/2);
    
    plot([0 90],[q q],'g')
    legend('D-B','Miki','Komatsu','Komatsu UNI', 'Location','Best')
    xlabel('Innfallsvinkel [Deg.]')
    ylabel('Absorpsjonskoeffisient')
    str1 = ['Absorpsjonskoeffisienten som funksjon av innfallsvinkel'];
    str2 = ['R_f_l_o_w: 550 kNsm^-^4, Frekvens: ',num2str(fcenter(ii)),' Hz'];
    title({str1; str2 })
    hold off
    pause
    
    Q(1,ii) = q;
    Q(2,ii) = 0;
    Q(3,ii) = fcenter(ii);
    
%     pause
end

% for ii=1:1:6
%     QQ(1,ii) = mean(Q(1,flower(ii):fupper(ii)))
% end
Q(1,:)
odeon = [0.12217 0.18951 0.28543 0.41211 0.56095 0.70807]