% clear all

plot_SIM   = 0;

table_diff = 1;
plot_diff  = 1; % krever table_diff = 1

festningsparken = 0;

jjj = 0;
iii = 1;
kkk = 100;
    
ii_offset = 2;

for jj = 0:0
for ii = 1+ii_offset:7
for kk = 100:50:2000
    ll = kk./50-1;
%        ll = kk./100;
    Lenght_kk = 39;
%     Lenght_kk = 10;
    % Tellere
    II = int2str(ii + 8*jj);
    JJ = int2str(jj + 1);
    KK = int2str(kk);
    MM = int2str(jj*90);
    NN = int2str(ii);
    
    %% Leser inn data
    % Simuleringer
    if ii == 1+ii_offset && jj == 0 && kk == 100
        SIM = zeros(Lenght_kk ,8);
        load('Sim_data\Sim_testing\fcenter.mat')
    end
    eval(['sim = load(''Sim_data\Var_imp\AH_DB\',MM,'_',NN,'_',KK,'.mat'');'])
    SIM(ll,:) = sim.L1;
    
    % Mledata (Testmlinger)
    
    if festningsparken == 1
        eval(['[AA, Fs1] = loadimp(''Festningsparken\serie',JJ,'\Meas_',NN,'.wmb'');']);
    else
        eval(['[AA, Fs1] = loadimp(''Testmaalinger\Meas_',II,'.wmb'');']);
    end
    
    if ii == 1+ii_offset && kk == 100
        eval(['REF_meas0 = loadimp(''Testmaalinger\Meas_',II,'.wmb'');']);    
        Noise0 = loadimp('Testmaalinger\noise.wmb');
    end
        Noise0 = loadimp('Testmaalinger\noise.wmb');
    
    % Tidsvindu
    if festningsparken == 1
        win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
        win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
        win3 = [4471 3801 3817 3703 3947 3316 2694 1517];
    else
        win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
        win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
        win3 = [4471 3801 3817 3703 3947 3316 2694 1517];
    end
   
    eval(['win = win',JJ,';']);
    
    [~,locs1] = findpeaks(AA, 'SORTSTR', 'descend');    
    [~,locs2] = findpeaks(REF_meas0, 'SORTSTR', 'descend');    

    
    % Ptrykker tidsvindu
    A = AA(locs1(1)-10:locs1(1)+win(ii)-10);
    REF_meas = REF_meas0(locs2(1)-10:105+win(2)-10);         
    Noise = Noise0(1:win(ii));
        
    % FFT
    L1 = length(A);
    NFFT1 = 2^(nextpow2(L1)+5);
    
    F1 = fft(A, NFFT1)/L1;
    F1 = F1(1:NFFT1/2+1).^2;
    
    F2 = fft(REF_meas, NFFT1)/L1;
    F2 = F2(1:NFFT1/2+1).^2;
    
    F3 = fft(Noise, NFFT1)/L1;
    F3 = F3(1:NFFT1/2+1).^2;
    
    %% Smoothing
%     octfrac = 3;
%     fstart = 100;
%     fend = 19953;
%     npoints = 24;
% 
    octfrac = 1;
    fstart = 121;
    fend = 15447;
    npoints = 8;

%     octfrac = 1;
%     fstart = 125;
%     fend = 16000;
%     npoints = 8;
    
    fvec1 = Fs1/2*linspace(0,1,NFFT1/2+1);
    
    
%     semilogx(fvec1,abs(10*log10(F1/((20*10^-6)))))
%     xlim([0 20000])
    
    [F1out,fvecout] = F2smospanew(fvec1,F1,octfrac,fstart,fend,npoints);
    [F2out]         = F2smospanew(fvec1,F2,octfrac,fstart,fend,npoints);
    [F3out]         = F2smospanew(fvec1,F3,octfrac,fstart,fend,npoints);
    
%     for ll = 1:8        
%         fcenter = 1000*(2.0).^[-2+ll];
%         fd = (2^0.5);
%         fupper = fcenter.*fd;
%         flower = fcenter./fd;
%         
%         if ll == 100
%            F1out = zeros(8,1); 
%            F2out = zeros(8,1); 
%            F3out = zeros(8,1); 
%         end
%         
% %         F1out = mean()
%     end
    
    % dB
    F1 = 10*log10(F1out/((20*10^-6)));
    F2 = 10*log10(F2out/((20*10^-6)));
    F3 = 10*log10(F3out/((20*10^-6)));
    
    if ii == iii && jj == jjj
        FR1 = zeros(npoints,1);
        FR2 = zeros(npoints,1);
        FR3 = zeros(npoints,1);
    end
    
    FR1(:,ll) = F1;
    FR2(:,ll) = F2;
    FR3(:,ll) = F3;
    
    % Plot 
fopen('all');   % Lister alle pne filer
fclose('all');  % Lukker alle pne filer
    
end

%% Plot & Table
    
    % Setter ref 0 dB
    maxFR1 = sort(max(FR1),'descend');
    FR1N  = FR1;  %- maxFR1(1);
    
    maxSIM = sort(max(SIM),'descend');
    SIMN = SIM;% - maxSIM(1);
    
    DIFF = FR1(1:6,:) + FR2(1:6,:) - SIM(:,3:8)';
    % Table
    if table_diff == 1
%         if ii == 3
%             Diff1 = zeros(9,6,8-ii_offset);
%             Diff2 = zeros(9,8-ii_offset);
%         end
        [jj ii ]
        for kkk = 1:Lenght_kk 
           Diff1(kkk,:,ii-ii_offset) = std(FR1N(1:6) - SIMN(kkk,3:8));
           
           Diff2(kkk,ii-ii_offset)   = mean(abs(Diff1(kkk,:,ii-ii_offset)));
        end
    end
    
    % SIM
    if plot_SIM == 1


    semilogx(fcenter, SIMN([3 7 11 16 19],:), '--x')
    hold on 
    semilogx(fvecout, FR1N,'-o')
    hold off
    grid on

    axis([100 4000 -20 5])
    xlabel('Frekvens [Hz]')
    ylabel('Magnitude [dB]')
%     title('SIM: Direct sound & First reflection')
    
    JJ = num2str(ii*2 - 1);
    eval(['title(''SIM: Ang:',MM, char(176) ', Avstand: ',JJ,' m'')']);
    
%     str_legend = {'100', '150', '200', '250', '300', '350', '400', '450', '500', 'Meas.'};
    str_legend = {'200', '400', '600', '800', '1000', 'Meas.'};
    legend(str_legend, 'Location', 'NorthWest')

    pause
    end
        
    if ii == 1+ii_offset
        diff = DIFF;
    else
        diff = [diff ; DIFF];
    end
    
    if jj == 0
        diff0 = diff;
    elseif jj == 1
        diff1 = diff;
    elseif jj == 2; 
        diff2 = diff;
    end
    
end
end

if table_diff == 1
    Diff3 = zeros(5,1);
    for kk = 1:Lenght_kk 
        Diff3(kk,1) = mean(Diff2(kk,:));
    end
    
    figure(1)
    hold on
%     plot(100:100:1000,Diff3,'-o')
    plot(100:50:2000,Diff3,'-ob')
%     axis([100 500 .67 .73])
    xlabel('R_f_l_o_w [kNsm^-^4]', 'FontSize', 16)
    ylabel('STD [dB]', 'FontSize', 16)
    title('Total mean STD: Meas./SIM', 'FontSize', 16)
    set(gca,'FontSize', 16)

%     figure(2)
%     plot(1:6,Diff2(3:end,:), '-o')
%     set(gca,'XTick',[1:1:6])
%     set(gca, 'XTickLabel',fcenter(3:8))
%     xlabel('Octave bands [f_c_e_n_t_e_r]', 'FontSize', 14)
%     ylabel('Diff. [dB]', 'FontSize', 14)
%     title('Mean diff per octave. : Meas./Sim.', 'FontSize', 14);
%     set(gca,'FontSize',14)
%     hleg = legend('200','250','300','350','400','450','500');
%     htitle = get(hleg,'Title');
%     set(htitle,'String','R_f_l_o_w', 'FontSize', 14)
%     axis([125 4000 .3 1.1])
%     pause
end
%     hleg = legend('Akustikkhallen','Festningsparken');
%     htitle = get(hleg,'Title');
%     set(htitle,'String','Ref. mling', 'FontSize', 14)
    
%% Lukk alt 
fopen('all');   % Lister alle pne filer
fclose('all');  % Lukker alle pne filer
% close all       % Lukker alle plot