clear all

plot_freq = 0;
plot_SNR  = 0;
plot_IR   = 1;
plot_SIM  = 0;
plot_SvsM = 0;

histogram = 0;
totaler   = 1;
detaljert = 0;
avvik     = 1;
dempning  = 0;
plot_STD  = 0;

filtrer   = 1;
hoyde     = 0;

OMNI      = 0;
TestMaal  = 0;

Blp = fir1(5000,[50 7000]./(24000)); % LP-filter

if hoyde == 1
    x = 0;
    y = 10;
else
    x = 2;
    y = 7;
end

for kk = 550
for jj = 0:x
for ii = 1:y
    
    % Tellere
    II = int2str(ii + 8*jj);
    JJ = int2str(jj + 1);
    KK = int2str(kk);
    LL = int2str(ii+10-1);
    MM = int2str(jj*90);
    NN = int2str(ii);
       
    
    %% Leser inn data
    % Simuleringer
    if ii == 1 && jj == 0
%         SIM_CATT_0 = zeros(8192,1);
        SIM = zeros(21,8);
        load('Sim_data\Sim_testing\fcenter.mat')
    end
    
    if OMNI == 1
        Direktivitet = 'OMNI';
    else
        Direktivitet = 'Direk';
    end
    
    if TestMaal == 1
        Lokasjon = 'GmlElektro';
    else
        Lokasjon = 'Festningsparken';
    end
    
    if hoyde == 1
        eval(['sim = load(''Simuleringer\CATT\Festningsparken\',Direktivitet,'\hoyde\E_A0_',LL,'_M.mat'');'])
        SIM_CATT_0 = sim.pp_ir;
        
        eval(['sim = load(''Simuleringer\MATLAB\Festningsparken\Hoyde\0_',NN,'_',KK,'.mat'');'])
        SIM(ii+7*jj,:) = sim.L1;
    elseif OMNI == 1
       eval(['sim = load(''Simuleringer\CATT\Festningsparken\',Direktivitet,'\E_A0_0',NN,'_M.mat'');'])
       SIM_CATT_0 = sim.pp_ir;

       eval(['sim = load(''Simuleringer\MATLAB\Festningsparken\',Direktivitet,'\',MM,'_',NN,'_',KK,'.mat'');'])
       SIM(ii+7*jj,:) = sim.L1;   
    else
       eval(['sim = load(''Simuleringer\CATT\',Lokasjon,'\',Direktivitet,'\',MM,'\E_A0_0',NN,'_M.mat'');'])
       SIM_CATT_0 = sim.pp_ir;
% SIM_CATT_0 = zeros(1,10000);
       eval(['sim = load(''Simuleringer\MATLAB\',Lokasjon,'\',Direktivitet,'\',MM,'_',NN,'_',KK,'.mat'');'])
       SIM(ii+7*jj,:) = sim.L1;
    end
    
    % Mledata 
    if hoyde == 1
        eval(['[AA, Fs1] = loadimp(''Festningsparken\serie4\Meas_',NN,'.wmb'');']);
    elseif TestMaal == 1
        eval(['[AA, Fs1] = loadimp(''Testmaalinger\Meas_',II,'.wmb'');']);
    else
        eval(['[AA, Fs1] = loadimp(''Festningsparken\serie',JJ,'\Meas_',NN,'.wmb'');']);
    end
    
    % Legg til: load REF_meas........
       
    if ii == 1
        Noise = loadimp('Festningsparken\serie0\Meas_1.wmb');
    end
    
    %% Filter
    if filtrer == 1
       AA = conv(Blp,AA);
%        NN = conv(Blp,Noise);
       NN = AA(20000:40000);

    end
      
    %% Tidsvindu
    % Dir.lyd + refl.

   win1 = [4471 4099 3829 3681 3332 2662 2205 1582];
   win2 = [3500 3389 2762 2308 2351 2329 2119 1723];
   win3 = [4471 3801 3817 3703 3947 3316 2694 1517];


    
    % Ref_meas (Dir.lyd)
%     win4 = [880 900 855];
    
    % Dir.lyd
%     win1 = [880 632 574 506 454 404 380];
%     win2 = [900 723 600 469 418 438 414];
%     win3 = [855 675 572 482 442 342 347];
   
    eval(['win = win',JJ,';']);

    
    [~,locs1] = findpeaks(AA, 'SORTSTR', 'descend');    
%     [~,locs2] = findpeaks(REF_meas0, 'SORTSTR', 'descend');   
    
    %% Ptrykker tidsvindu
    if ii == 1 && jj == 0
%             REF_meas = AA(2456:3363);
        REF_meas = loadimp('Meas_data\2.wmb');
        REF_meas = REF_meas(126:485);
    end
    
    if hoyde == 1
        if ii <= 5
            winH = win(3);
        else
            winH = win(4);
        end
        
        A = AA(locs1(1)-200:locs1(1)+winH-250);
        SIM_CATT = SIM_CATT_0(1:winH-10);  
        Noise = NN(1:winH);
    else
        A = AA(locs1(1)-200:locs1(1)+win(ii)-250);
        SIM_CATT = SIM_CATT_0(1:win(ii)-250);  
%         SIM_CATT = SIM_CATT_0;
        Noise = NN(1:win(ii));
        
%         plot(SIM_CATT)
%         hold on
%         plot(A+0.01,'r')
%         hold off
%         pause
    end
        
    %% FFT
    L1 = length(A);
    L2 = length(SIM_CATT);
    L3 = length(Noise);
    L4 = length(REF_meas);
    
    NFFT1 = 2^(nextpow2(L1)+5);
    NFFT2 = 2^(nextpow2(L2)+5);
    NFFT3 = 2^(nextpow2(L3)+5);
    NFFT4 = 2^(nextpow2(L4)+5);
    
    F1 = fft(A       , NFFT1)/L1;
    F2 = fft(SIM_CATT, NFFT2)/L2;
    F3 = fft(Noise   , NFFT3)/L3;
    F4 = fft(REF_meas, NFFT4)/L4;
    
    F1 = F1(1:NFFT1/2+1).^2;
    F2 = F2(1:NFFT2/2+1).^2;
    F3 = F3(1:NFFT3/2+1).^2; 
    F4 = F4(1:NFFT4/2+1).^2; 
        
    %% Smoothing
%     octfrac = 3;
%     fstart = 100;
%     fend = 19953;
%     npoints = 24;
    
    octfrac = 1;
    fstart = 121;
    fend = 15447;
    npoints = 8;
    
    fvec1 = Fs1/2*linspace(0,1,NFFT1/2+1);
    fvec2 = Fs1/2*linspace(0,1,NFFT2/2+1);
    fvec3 = Fs1/2*linspace(0,1,NFFT3/2+1);
    fvec4 = Fs1/2*linspace(0,1,NFFT4/2+1);
    
    [F1out,fvecout] = F2smospanew(fvec1,F1,octfrac,fstart,fend,npoints);
    [F2out]         = F2smospanew(fvec2,F2,octfrac,fstart,fend,npoints);
    [F3out]         = F2smospanew(fvec3,F3,octfrac,fstart,fend,npoints);
    [F4out]         = F2smospanew(fvec4,F4,octfrac,fstart,fend,npoints);
    
    % dB
    F1 = 10*log10(F1out);
    F2 = 10*log10(F2out);
    F3 = 10*log10(F3out);
    F4 = 10*log10(F4out);
    
    if ii == 1 && jj == 0
        FR1 = zeros(npoints,21);
        FR2 = zeros(npoints,21);
        FR3 = zeros(npoints,21);
        FR4 = zeros(npoints,21);
    end
    
    if hoyde == 1
        FR1(:,ii) = F1;
        FR2(:,ii) = F2;
        FR3(:,ii) = F3;
        FR4(:,ii) = F4;
    else
        FR1(:,ii + 7*jj) = F1;
        FR2(:,ii + 7*jj) = F2;
        FR3(:,ii + 7*jj) = F3;
        FR4(:,ii + 7*jj) = F4;
    end
    
    % Plot 
    
    %% IR Mlinger
    if plot_IR == 1        
               
        plot((1:length(AA(locs1(1)-200:end)))./48 , AA(locs1(1)-200:end))
        hold on
        plot((1:length(A))./48, A, 'r')
% 
%         plot(REF_meas0(locs2(1)-200:end))
%         hold on
%         plot(REF_meas,'r')

        grid on
        hold off
        
%         xlim([0 200])
        xlim([0000 5000/48])
        ylim([-45 55].*10^-3)

        xlabel('Tid [ms]')
        ylabel('Amplitude')
        legend('Forkastet','Benyttet')
        
        if hoyde == 1
            if ii <= 5
                title(['Avstand - 5 m, Hyde ',num2str(2.9-0.5*(ii-1)),' m'])
                
            else
                title(['Avstand - 10.3 m, Hyde ',num2str(2.9-0.5*(ii-1-5)),' m'])
            end
        else
            JJ = num2str(ii*2-1);
            eval(['title(''Avstand - ',JJ,'m'')']);
        end
       
        pause        
    end
   
end
end
end

    %% Setter ref. 
    if OMNI == 1
        FR1N  = FR1 + 67;    
        SIMN1(:,1:2) = SIM(:,1:2) + 70;
        SIMN1(:,3:8) = SIM(:,3:8) + 63 + FR4(1:6,:)' - 21;
        SIMN2 = FR2 + 69 + 56.66 + FR4 - 84.5 - 1;
    else
        FR1N  = FR1 + 67;    
%         SIMN1 = SIM + 11 + 125*0 - 20;
        SIMN1(:,1:2) = SIM(:,1:2) + 50;
        SIMN1(:,3:8) = SIM(:,3:8) + 42 + FR4(1:6,:)' + 125*0 ;
        SIMN2 = FR2 + 69 + 56.66 + FR4 - 84.5;
    end

 
    %% Freq

if hoyde == 1
   y = 5; 
end

for ii = 1:y
    if plot_freq == 1
                
        if hoyde == 0
            
            figure(1)
            
            semilogx(fvecout, FR1N(:,ii + 8*0), '-ob')
            hold on
            semilogx(fvecout, FR1N(:,ii + 8*1), '-or')
            semilogx(fvecout, FR1N(:,ii + 8*2), '-og')
            
            hold off
            grid on

            axis([100 5000 -65 5])

            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')

            JJ = num2str(ii*2 - 1);
            title(['Meas: Avstand - ' JJ ' m'])

            legend(['Mling 0' char(176)], ['Mling 90' char(176)], ['Mling 180' char(176)], ...
                'Location','SouthWest')

            if ii == 1
                Diff_rot = zeros(3,8);
            end

            Diff_rot(1,ii) = mean(FR1N(:,ii + 8*0));
            Diff_rot(2,ii) = mean(FR1N(:,ii + 8*1));
            Diff_rot(3,ii) = mean(FR1N(:,ii + 8*2));

    %         if ii == 8
    %             plot([1:2:15], Diff_rot, '-o')
    %             
    %             axis([0 15 -30 0])
    %             xlabel('Dist. [m]')
    %             ylabel('Magnitude [dB]')
    %             title('Mean Magnitude as function of distance')
    %             
    %             hold on
    %             test = 20*log10((1./[1:2:15])/((20*10^-6)));
    %             plot([1:2:15], test-94, '--+')
    %             plot([1:2:15], test-104, '--+g')
    %             plot([1:2:15], test-112, '--+r')
    %             
    %             grid on
    %             
    %             legend(['Mling 0' char(176)], ['Mling 90' char(176)], ['Mling 180' char(176)], ...
    %             '1/r - 47 dB', '1/r - 57 dB', '1/r - 65 dB', 'Location','NorthEast')
    %         end
        else
            figure(1)
            
            semilogx(fvecout, FR1N(:,1:5 + 0))        
          
            grid on

            axis([100 5000 -45 -10])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')

%             JJ = num2str(2.9 - 0.5*(ii-1));
            title('Avtand 5 m')

            hleg = legend('2.9 m', '2.4 m', '1.9 m', '1.4 m', '0.9 m', 'Location','SouthEast');
            htitle = get(hleg,'Title');
            set(htitle,'String','Mlehyde')
            
            
            figure(2)
            
            semilogx(fvecout, FR1N(:,6:10))  
            
            grid on

            axis([100 5000 -45 -10])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')

            JJ = num2str(2.9 - 0.5*(ii-1));
            title('Avstand 10 m')

            hleg = legend('2.9 m', '2.4 m', '1.9 m', '1.4 m', '0.9 m', 'Location','SouthEast');
            htitle = get(hleg,'Title');
            set(htitle,'String','Mlehyde')
        end
        
        pause
    end


    
    %% SNR
    if plot_SNR == 1
        
%         SNR1(ii,:) = [FR1(:,ii + 7*0) - FR3(:,ii + 7*0)];
%         SNR2(ii,:) = [FR1(:,ii + 7*1) - FR3(:,ii + 7*1)];
        SNR3(ii,:) = [FR1(:,ii + 7*2) - FR3(:,ii + 7*2)];
        figure(2)

        semilogx(fvecout, FR1(:,ii + 7*0) - FR3(:,ii + 7*0), '-ob')
        hold on
        semilogx(fvecout, FR1(:,ii + 7*1) - FR3(:,ii + 7*1), '-or')
        semilogx(fvecout, FR1(:,ii + 7*2) - FR3(:,ii + 7*2), '-og')

        grid on
        hold off

        axis([0 5000 15 70])
        xlabel('Frekvens [Hz]')
        ylabel('SNR [dB]')

        JJ = num2str(ii*2 - 1);
        title(['Meas: Avstand - ' JJ ' m'])

        legend(['0' char(176)], ['90' char(176)], ['180' char(176)], ...
            'Location','NorthWest')
        
        pause
    end

    %% SIM
    if plot_SIM == 1
        figure(3)
        semilogx(fcenter,SIMN1(ii + 8*0,:), '--ob')
        hold on
        grid on
        semilogx(fcenter,SIMN1(ii + 8*1,:), '--or')
        semilogx(fcenter,SIMN1(ii + 8*2,:), '--og')
        hold off
        
        axis([100 5000 -65 5])
        xlabel('Frekvens [Hz]')
        ylabel('Magnitude [dB]')
        title('SIM: Direct sound & First reflection')
        
        pause
    end
    
    %% SIM vs Meas. 
    if plot_SvsM == 1
        if hoyde == 0
            JJ = num2str(ii*2 - 1);

            figure(1)
            semilogx(fvecout, FR1N(:,ii + 7*0), '-ob')
            hold on
            grid on
            semilogx(fcenter,SIMN1(ii + 7*0,:), '-or')
            semilogx(fvecout,SIMN2(:,ii + 7*0), '-ok')
            hold off

            axis([100 4000 -65 5])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')
            title({'Direct sound & First reflection:', ['Ang: 0 ' ...
                char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
            str_legend = {'Meas.', 'Sim. (MATLAB)', 'Sim. (CATT)'};
            legend(str_legend, 'Location', 'SouthWest')

            figure(2)
            semilogx(fvecout, FR1N(:,ii + 7*1), '-ob')
            hold on
            grid on
            semilogx(fcenter,SIMN1(ii + 7*1,:), '-or')
            semilogx(fvecout,SIMN2(:,ii + 7*1), '-ok')
            hold off

            axis([100 4000 -65 5])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')
            title({'Direct sound & First reflection:', ['Ang: 90 ' ...
                char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
            str_legend = {'Meas.', 'Sim. (MATLAB)', 'Sim. (CATT)'};
            legend(str_legend, 'Location', 'SouthWest')

            figure(3)
            semilogx(fvecout, FR1N(:,ii + 7*2), '-ob')
            hold on
            grid on
            semilogx(fcenter,SIMN1(ii + 7*2,:), '-or')
            semilogx(fvecout,SIMN2(:,ii + 7*2), '-ok')
            hold off

            axis([100 4000 -65 5])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')
            title({'Direct sound & First reflection:', ['Ang: 180 ' ...
                char(176) ', Dist: ' JJ ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
            str_legend = {'Meas.', 'Sim. (MATLAB)', 'Sim. (CATT)'};
            legend(str_legend, 'Location', 'SouthWest')

            pause    
            
        else
            figure(1)
            semilogx(fvecout, FR1N(:,ii), '-ob')
            hold on
            grid on
            semilogx(fcenter,SIMN1(ii,:), '-or')
            semilogx(fvecout,SIMN2(:,ii), '-ok')
            hold off

            II = num2str(2.9-0.5*(ii-1));
            axis([100 4000 -65 5])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')
            title({'Direct sound & First reflection:', ...
                ['Dist: 5 m, Higth: ' II ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
            legend('Meas.', 'Sim.','CATT', 'Location', 'SouthWest')

            figure(2)
            semilogx(fvecout, FR1N(:,ii + 5), '-ob')
            hold on
            grid on
            semilogx(fcenter,SIMN1(ii+5,:), '-or')
            semilogx(fvecout,SIMN2(:,ii + 5), '-ok')
            hold off

            axis([100 4000 -65 5])
            xlabel('Frekvens [Hz]')
            ylabel('Magnitude [dB]')
            title({'Direct sound & First reflection:', ...
                ['Dist: 10.3 m, Higth: ' II ' m, R_f_l_o_w: ' KK ' kNsm^-^4']})
            legend('Meas.', 'Sim.','CATT', 'Location', 'SouthWest')
            
            pause
        end
    end
end

%% Historgram
if histogram == 1
    for iii = 0:0
        for jjj = 0:0
    freqvar = iii;
distvar = jjj;

    [freqvar   distvar]
    %%%%%%%%%%%%%%%%%%%%% MATLAB %%%%%%%%%%%%%%%%%%%%%
    Diff1 = (SIMN1(1:7   ,3:8 ) - FR1N(1:6 , 1:7  )');
    Diff2 = (SIMN1(8:14  ,3:8 ) - FR1N(1:6 , 8:14 )');
    Diff3 = (SIMN1(15:21 ,3:8 ) - FR1N(1:6 ,15:21 )');

    Diff4 = [Diff1; Diff2; Diff3];

    Diff5 = (SIMN1(1:7   ,3:8 )' - FR1N(1:6 , 1:7  ));
    Diff6 = (SIMN1(8:14  ,3:8 )' - FR1N(1:6 , 8:14 ));
    Diff7 = (SIMN1(15:21 ,3:8 )' - FR1N(1:6 ,15:21 ));

    Diff8 = [Diff5; Diff6; Diff7];

    Diff9 = [Diff1(:) Diff2(:) Diff3(:)];
    Diff10 = Diff9(:);

    %%%%%%%%%%%%%%%%%%%%%%%% CATT %%%%%%%%%%%%%%%%%%%%%%%%
    Diff11 = (SIMN2(1:6, 1:7 )' - FR1N(1:6, 1:7 )');
    Diff12 = (SIMN2(1:6, 8:14)' - FR1N(1:6, 8:14)');
    Diff13 = (SIMN2(1:6,15:21)' - FR1N(1:6,15:21)');

    Diff14 = [Diff11; Diff12; Diff13];

    Diff15 = (SIMN2(1:6, 1:7 ) - FR1N(1:6, 1:7 ));
    Diff16 = (SIMN2(1:6, 8:14) - FR1N(1:6, 8:14));
    Diff17 = (SIMN2(1:6,15:21) - FR1N(1:6,15:21));

    Diff18 = [Diff15; Diff16; Diff17];

    Diff19 = [Diff11(:) Diff12(:) Diff13(:)];
    Diff20 = Diff19(:);

    %%%%%%%%%%%%%%%%%%%%% Hyde %%%%%%%%%%%%%%%%%%%%%
    Diff21 = (SIMN1(1:5 , 3:8 )  - FR1N(1:6 , 1:5 )');
    Diff22 = (SIMN1(6:10, 3:8 )  - FR1N(1:6, 6:10 )');
    
    Diff23 = (SIMN2(1:6, 1:5 )'  - FR1N(1:6, 6:10 )');
    Diff24 = (SIMN2(1:6, 6:10 )' - FR1N(1:6, 1:5 )');
    
    if avvik == 1
        for f = 1:6
            GSA_F1(1,f) = mean([std(Diff1(:,f)) std(Diff2(:,f)) std(Diff3(:,f))]);
            GSA_F2(1,f) = mean([std(Diff11(:,f)) std(Diff12(:,f)) std(Diff13(:,f))]);
        end
        
        for d = 1:7
            GSA_D1(1,d) = mean([std(Diff5(:,d)) std(Diff6(:,d)) std(Diff7(:,d))]);
            GSA_D2(1,d) = mean([std(Diff15(:,d)) std(Diff16(:,d)) std(Diff17(:,d))]);
        end
        
            GSA_R1 = [std(Diff1(:)) std(Diff2(:)) std(Diff3(:))];
            GSA_R2 = [std(Diff11(:)) std(Diff12(:)) std(Diff13(:))];
        
            GSA_T1 = std([Diff1(:); Diff2(:); Diff3(:)]);
            GSA_T2 = std([Diff11(:); Diff12(:); Diff13(:)]);
            

        
%             GSA_R1 = [mean(std(Diff1(:,:))) mean(std(Diff2(:,:))) mean(std(Diff3(:,:)))];
%             GSA_R2 = [mean(std(Diff11(:,:))) mean(std(Diff12(:,:))) mean(std(Diff13(:,:)))];
%             
%             GSA_T1 = mean(GSA_R1);
%             GSA_T2 = mean(GSA_R2);


        
%         [125 250 500 1 2 4 ; GSA_F1 ; GSA_F2]            
%         [1:2:13 ; GSA_D1 ; GSA_D2]
%         [0 90 180 ; GSA_R1 ; GSA_R2]
%         [GSA_T1 ; GSA_T2]
        
%        avvik_MATLAB_dist = ([mean(std(Diff1)) mean(std(Diff2)) mean(std(Diff3))]);
%        avvik_MATLAB_freq = ([mean(std(Diff5)) mean(std(Diff6)) mean(std(Diff7))]);
%        avvik_CATT_dist = ([mean(std(Diff11)) mean(std(Diff12)) mean(std(Diff13))]);
%        avvik_CATT_freq = ([mean(std(Diff15)) mean(std(Diff16)) mean(std(Diff17))]);
%        
% %        disp(' ')
% %        disp(['Ang. (deg)          0          90         180        Mean'])
%        div_avvik = ([[avvik_MATLAB_freq; avvik_MATLAB_dist; avvik_CATT_freq; avvik_CATT_dist]...
%               mean([avvik_MATLAB_freq; avvik_MATLAB_dist; avvik_CATT_freq; avvik_CATT_dist],2)]);
% %        text_str = num2str(div_avvik);
% %        disp([['MAT. (freq)   ';'MAT. (dist)   ';'CATT (freq)   ';'CATT (dist)   '] [text_str]]);
%     matfreq(iii+1,jjj+1) = mean(avvik_MATLAB_freq);
%     matdist(iii+1,jjj+1) = mean(avvik_MATLAB_dist);
%     catfreq(iii+1,jjj+1) = mean(avvik_CATT_freq);
%     catdist(iii+1,jjj+1) = mean(avvik_CATT_dist);
    end
        end
    end
    
        strMATLAB = 'MATLAB Komatsu UNI';
        strCATT   = 'CATT Komatsu UNI';
        
    if totaler == 1
        
%         strMATLAB = 'MATLAB Komatsu';
        

        
%         strMATLAB = 'MATLAB Komatsu OMNI';
%         strCATT   = 'CATT Komatsu OMNI';
        
        
        figure(4)
        hist(Diff4)
%         axis([-15 10 0 15])
        str_legend = {['125 Hz (' num2str(round(GSA_F1(1,1)*10)/10) ')'], ...
            ['250 Hz (' num2str(round(GSA_F1(1,2)*10)/10) ')'], ...
            ['500 Hz (' num2str(round(GSA_F1(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F1(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F1(1,5)*10)/10) ')'], ... 
            ['  4 kHz (' num2str(round(GSA_F1(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Frekvens (GSA [dB])');
        title(strMATLAB)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
%         pause
        figure(8)
        hist(Diff8)   
%         axis([-15 10 0 15])
        str_legend = {['  1 m (' num2str(round(GSA_D1(1,1)*10)/10) ')'], ...
            ['  3 m (' num2str(round(GSA_D1(1,2)*10)/10) ')'], ...
            ['  5 m (' num2str(round(GSA_D1(1,3)*10)/10) ')'], ... 
            ['  7 m (' num2str(round(GSA_D1(1,4)*10)/10) ')'], ... 
            ['  9 m (' num2str(round(GSA_D1(1,5)*10)/10) ')'], ... 
            ['11 m (' num2str(round(GSA_D1(1,6)*10)/10) ')'], ...
            ['13 m (' num2str(round(GSA_D1(1,7)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Avstand (GSA [dB])');
        title(strMATLAB)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')

        figure(9)
        hist(Diff9)   
        str_legend = {['    0' char(176) '(' num2str(round(GSA_R1(1,1)*100)/100) ')'], ...
            ['  90' char(176) '(' num2str(round(GSA_R1(1,2)*100)/100) ')'], ...
            ['180' char(176) '(' num2str(round(GSA_R1(1,3)*100)/100) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Rotasjon (SA [dB])');
        title(strMATLAB)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')

        figure(10)
        hist(Diff10)   
        str_legend = num2str(round(GSA_T1*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title(strMATLAB)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')
        %         axis([-15 10 0 45])
        
        pause
        
        figure(4)
        hist(Diff14)
%         axis([-15 10 0 15])
        str_legend = {['125 Hz (' num2str(round(GSA_F2(1,1)*10)/10) ')'], ...
            ['250 Hz (' num2str(round(GSA_F2(1,2)*10)/10) ')'], ...
            ['500 Hz (' num2str(round(GSA_F2(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F2(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F2(1,5)*10)/10) ')'], ... 
            ['  4 kHz (' num2str(round(GSA_F2(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Frekvens (GSA [dB])');
        title(strCATT)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')

        figure(8)
        hist(Diff18)   
%         axis([-15 10 0 15])
        str_legend = {['  1 m (' num2str(round(GSA_D2(1,1)*10)/10) ')'], ...
            ['  3 m (' num2str(round(GSA_D2(1,2)*10)/10) ')'], ...
            ['  5 m (' num2str(round(GSA_D2(1,3)*10)/10) ')'], ... 
            ['  7 m (' num2str(round(GSA_D2(1,4)*10)/10) ')'], ... 
            ['  9 m (' num2str(round(GSA_D2(1,5)*10)/10) ')'], ... 
            ['11 m (' num2str(round(GSA_D2(1,6)*10)/10) ')'], ...
            ['13 m (' num2str(round(GSA_D2(1,7)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Avstand (GSA [dB])');
        title(strCATT)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')

        figure(9)
        hist(Diff19)   
%         axis([-15 10 0 30])
        str_legend = {['    0' char(176) '(' num2str(round(GSA_R2(1,1)*100)/100) ')'], ...
            ['  90' char(176) '(' num2str(round(GSA_R2(1,2)*100)/100) ')'], ...
            ['180' char(176) '(' num2str(round(GSA_R2(1,3)*100)/100) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Rotasjon (SA [dB])');
        title(strCATT)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')

        figure(10)
        hist(Diff20)   
%         axis([-15 10 0 45])
        str_legend = num2str(round(GSA_T2*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title(strCATT)
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')
    end
    
    if detaljert == 1
        figure(1)    
        hist(Diff1)
    %     axis([-12 8 0 5])
        str_legend = {'125 Hz','250 Hz','500 Hz','1 kHz','2 kHz','4 kHz'};
        legend(str_legend, 'Location', 'NorthEast')
        title(['0' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:3)

        figure(2)
        hist(Diff2)
    %     axis([-12 8 0 5])
        legend(str_legend, 'Location', 'NorthEast')
        title(['90' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:4)

        figure(3)
        hist(Diff3)
    %     axis([-12 8 0 5])
        legend(str_legend, 'Location', 'NorthEast')
        title(['180' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:4)
        
        pause

        figure(5)    
        hist(Diff5)
    %     axis([-12 8 0 6])
        str_legend = {'1 m','3 m','5 m','7 m','9 m','11 m', '13 m'};
        legend(str_legend, 'Location', 'NorthEast')
        title(['0' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:5)

        figure(6)
        hist(Diff6)
    %     axis([-12 8 0 6])
        legend(str_legend, 'Location', 'NorthEast')
        title(['180' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:4)

        figure(7)
        hist(Diff7)
    %     axis([-12 8 0 6])
        legend(str_legend, 'Location', 'NorthEast')
        title(['180' char(176)])
        set(gca, 'YGrid', 'on', 'Ytick', 0:3)
    end
    
    if hoyde == 1
        
        GSA_F21 = std(Diff21);
        GSA_F22 = std(Diff22);
        GSA_F23 = std(Diff23);
        GSA_F24 = std(Diff24);

        GSA_D21 = std(Diff21,0,2)';
        GSA_D22 = std(Diff22,0,2)';
        GSA_D23 = std(Diff23,0,2)';
        GSA_D24 = std(Diff24,0,2)';
        
        GSA_T21 = std(Diff21(:))
        GSA_T22 = std(Diff22(:))
        GSA_T23 = std(Diff23(:))
        GSA_T24 = std(Diff24(:))


        figure(1)
        hist(Diff21')
        str_legend = { ...
            ['2.9 m (' num2str(round(GSA_D21(1,1)*10)/10) ')'], ...
            ['2.4 m (' num2str(round(GSA_D21(1,2)*10)/10) ')'], ... 
            ['1.9 m (' num2str(round(GSA_D21(1,3)*10)/10) ')'], ... 
            ['1.4 m (' num2str(round(GSA_D21(1,4)*10)/10) ')'], ... 
            ['0.9 m (' num2str(round(GSA_D21(1,5)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthWest');
        v = get(h,'title');
        set(v,'string','Hyde (SA [dB])');
        title('MATLAB Komatsu, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        
        figure(2)
        hist(Diff21)
                str_legend = { ...
             ['125 Hz (' num2str(round(GSA_F21(1,1)*10)/10) ')'], ...
             ['250 Hz (' num2str(round(GSA_F21(1,2)*10)/10) ')'], ... 
             ['500 Hz (' num2str(round(GSA_F21(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F21(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F21(1,5)*10)/10) ')'], ...
            ['  4 kHz (' num2str(round(GSA_F21(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthWest');
        v = get(h,'title');
        set(v,'string','Frekvens (SA [dB])');
        title('MATLAB Komatsu, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(3)
        hist(Diff22')
        str_legend = { ...
            ['2.9 m (' num2str(round(GSA_D22(1,1)*10)/10) ')'], ...
            ['2.4 m (' num2str(round(GSA_D22(1,2)*10)/10) ')'], ... 
            ['1.9 m (' num2str(round(GSA_D22(1,3)*10)/10) ')'], ... 
            ['1.4 m (' num2str(round(GSA_D22(1,4)*10)/10) ')'], ... 
            ['0.9 m (' num2str(round(GSA_D22(1,5)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Hyde (SA [dB])');
        title('MATLAB Komatsu, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(4)
        hist(Diff22)
                str_legend = { ...
             ['125 Hz (' num2str(round(GSA_F22(1,1)*10)/10) ')'], ...
             ['250 Hz (' num2str(round(GSA_F22(1,2)*10)/10) ')'], ... 
             ['500 Hz (' num2str(round(GSA_F22(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F22(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F22(1,5)*10)/10) ')'], ...
            ['  4 kHz (' num2str(round(GSA_F22(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Frekvens (SA [dB])');
        title('MATLAB Komatsu, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')  
        
        
        
        pause
        
        
        
        figure(1)
        hist(Diff23')
        str_legend = { ...
            ['2.9 m (' num2str(round(GSA_D23(1,1)*10)/10) ')'], ...
            ['2.4 m (' num2str(round(GSA_D23(1,2)*10)/10) ')'], ... 
            ['1.9 m (' num2str(round(GSA_D23(1,3)*10)/10) ')'], ... 
            ['1.4 m (' num2str(round(GSA_D23(1,4)*10)/10) ')'], ... 
            ['0.9 m (' num2str(round(GSA_D23(1,5)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Hyde (SA [dB])');
        title('CATT Komatsu UNI, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(2)
        hist(Diff23)
                str_legend = { ...
             ['125 Hz (' num2str(round(GSA_F23(1,1)*10)/10) ')'], ...
             ['250 Hz (' num2str(round(GSA_F23(1,2)*10)/10) ')'], ... 
             ['500 Hz (' num2str(round(GSA_F23(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F23(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F23(1,5)*10)/10) ')'], ...
            ['  4 kHz (' num2str(round(GSA_F23(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Frekvens (SA [dB])');
        title('CATT Komatsu UNI, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(3)
        hist(Diff24')
        str_legend = { ...
            ['2.9 m (' num2str(round(GSA_D24(1,1)*10)/10) ')'], ...
            ['2.4 m (' num2str(round(GSA_D24(1,2)*10)/10) ')'], ... 
            ['1.9 m (' num2str(round(GSA_D24(1,3)*10)/10) ')'], ... 
            ['1.4 m (' num2str(round(GSA_D24(1,4)*10)/10) ')'], ... 
            ['0.9 m (' num2str(round(GSA_D24(1,5)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Hyde (SA [dB])');
        title('CATT Komatsu UNI, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(4)
        hist(Diff24)
                str_legend = { ...
             ['125 Hz (' num2str(round(GSA_F24(1,1)*10)/10) ')'], ...
             ['250 Hz (' num2str(round(GSA_F24(1,2)*10)/10) ')'], ... 
             ['500 Hz (' num2str(round(GSA_F24(1,3)*10)/10) ')'], ... 
            ['  1 kHz (' num2str(round(GSA_F24(1,4)*10)/10) ')'], ... 
            ['  2 kHz (' num2str(round(GSA_F24(1,5)*10)/10) ')'], ...
            ['  4 kHz (' num2str(round(GSA_F24(1,6)*10)/10) ')']};
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','Frekvens (SA [dB])');
        title('CATT Komatsu UNI, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on')  
        
        
        pause
        
        
        figure(1)
        hist(Diff21(:))
        str_legend = num2str(round(GSA_T21*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title('MATLAB Komatsu, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(2)
        hist(Diff22(:))
        str_legend = num2str(round(GSA_T22*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title('MATLAB Komatsu, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(3)
        hist(Diff23(:))
        str_legend = num2str(round(GSA_T23*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title('CATT Komatsu UNI, 5 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
        
        figure(4)
        hist(Diff24(:))
        str_legend = num2str(round(GSA_T24*100)/100);
        h = legend(str_legend, 'Location', 'NorthEast');
        v = get(h,'title');
        set(v,'string','SA [dB]');
        title('CATT Komatsu UNI, 10.3 m')
        xlabel('Avvik mellom simulering og mledata [dB]')
        ylabel('Antall')
        set(gca, 'YGrid', 'on') 
    end
end


if dempning == 1
    rvec = 1:2:13;
%     semilogx(rvec,FR1N(6-0,1:7)-10*0,'--o', rvec,SIMN1(1:7,8-0)-1-10*0,'-o')
%     hold on
%     semilogx(rvec,FR1N(6-1,1:7)-10*1,'--o', rvec,SIMN1(1:7,8-1)-2-10*1,'-o')
%     semilogx(rvec,FR1N(6-2,1:7)-10*2,'--o', rvec,SIMN1(1:7,8-2)-2-10*2,'-o')
%     semilogx(rvec,FR1N(6-3,1:7)-10*3,'--o', rvec,SIMN1(1:7,8-3)-2-10*3,'-o')
%     semilogx(rvec,FR1N(6-4,1:7)-10*4,'--o', rvec,SIMN1(1:7,8-4)-2-10*4,'-o')
%     semilogx(rvec,FR1N(6-5,1:7)-10*5,'--o', rvec,SIMN1(1:7,8-5)-2-10*5,'-o')

    semilogx(rvec,FR1N(6-0,1:7)-10*0,'--o', rvec,SIMN1(1:7,8-0)+1.5-10*0,'-o')
    hold on
    semilogx(rvec,FR1N(6-1,1:7)-10*1,'--o', rvec,SIMN1(1:7,8-1)-1-10*1,'-o')
    semilogx(rvec,FR1N(6-2,1:7)-10*2,'--o', rvec,SIMN1(1:7,8-2)-1-10*2,'-o')
    semilogx(rvec,FR1N(6-3,1:7)-10*3,'--o', rvec,SIMN1(1:7,8-3)-1-10*3,'-o')
    semilogx(rvec,FR1N(6-4,1:7)-10*4,'--o', rvec,SIMN1(1:7,8-4)-2-10*4,'-o')
    semilogx(rvec,FR1N(6-5,1:7)-10*5,'--o', rvec,SIMN1(1:7,8-5)-2-10*5,'-o')

    hold off
    axis([0 13 -83 2])
    legend('Meas.', 'Sim')
    title('Dempning 1/r, Meas. vs Sim.')
    xlabel('Avstand: Kilde til mottaker [m]')
    ylabel('Magnitude [dB]')
end

if plot_STD == 1
    figure(1)
    semilogx(fcenter(3:8 ),[std(Diff1); std(Diff2); std(Diff3)],'-o')
    hold on
    semilogx(fcenter(3:8 ),[std(Diff11); std(Diff12); std(Diff13)],'--*')
    legend('0 MAT','90','180','0 CAT','90','180','Location','NorthEast')
    xlabel('Frekvens [Hz]')
    ylabel('Standardavvik [dB]')
    grid on
    hold off

    figure(2)
    plot(1:2:13-(distvar*2),[std(Diff5); std(Diff6); std(Diff7)],'-o')
    hold on
    plot(1:2:13-(distvar*2),[std(Diff15); std(Diff16); std(Diff17)],'--*')
    legend('0 MAT','90','180','0 CAT','90','180','Location','NorthEast')
    xlabel('Avstand [m]')
    ylabel('Standardavvik [dB]')
    grid on
    hold off
end

%% Lukk alt 
fopen('all');   % Lister alle pne filer
fclose('all');  % Lukker alle pne filer
% close all       % Lukker alle plot