clear all

plot_freq  = 1;
plot_IR    = 0;
plot_multi = 0;
plot_diff  = 0;
histogram  = 0;
filtrer    = 0; 

if plot_multi == 1 && filtrer == 1
   filtrer = 0; 
end

Blp = fir1(50,2000/(24000)); % LP-filter
iii = 10;
for ii = 5 %1:iii
    
    % Tellere
    II = int2str(ii);
    
    %% Akustikkhallen
    
    % Leser inn data
    eval(['[AA, Fs1] = loadimp(''Meas_data\',II,'.wmb'');']);
        
    REF_meas = loadimp('Meas_data\2.wmb');
    REF_meas = REF_meas(1:1000);
    
    % Tidsvindu
    win1 = [0.0084 0.0074 0.0064  0.0056  0.0049  0.0044  0.0040 0.0036 0.0033  0.0017];    % Direktelyd
    win2 = [0.0115 0.0104 0.00935 0.00835 0.00755 0.00665 0.0059 0.0056 0.00455 0.0045];    % /m gulvrefleks.
    win3 = [0.0112 0.0101 0.00915 0.00821 0.00751 0.00685 0.0063 0.0057 0.00443 0.0041];    % /m gulvrefleks. (Sim.)
    win = win2;
    
    [~,locs1] = findpeaks(AA, 'SORTSTR', 'descend');    
    [~,locs2] = findpeaks(REF_meas, 'SORTSTR', 'descend');    
    
    % Filtrering for plot_multi
    if plot_multi == 1
        if ii == 1       
            ir_meas_mat = zeros(2000, 10);
        end             
        AA = filter(Blp,1,AA);
        REF_meas = filter(Blp,1,REF_meas);
        
        ir_meas_mat(:,ii) = AA(1:2000);           
    end
    
    % Ptrykker tidsvindu
    A = AA(locs1(1)-10:locs1(1)+round(Fs1*win(ii)));
    REF_meas = REF_meas(locs2(1)-10:105+round(Fs1*win(2)));   
    
    % Filtrering
    if filtrer == 1
       A = filter(Blp,1,A);
       REF_meas = filter(Blp,1,REF_meas); 
    end
        
    % FFT
    L1 = length(A);
    NFFT1 = 2^(nextpow2(L1)+5);
    
    F1 = fft(A, NFFT1)/L1;
    F1 = F1(1:NFFT1/2+1).^2;
    F=F1;
    
    F2 = fft(REF_meas, NFFT1)/L1;
    F2 = F2(1:NFFT1/2+1).^2;
        
    %% Simulering
    Fs2 = 48000;
    
    % Leser inn data
    if ii < 10
        eval(['[BB] = load(''Sim_data\Med_dir\E_A0_0',II,'_M'', ''pp_ir'');']);
    else 
        eval(['[BB] = load(''Sim_data\Med_dir\E_A0_',II,'_M'', ''pp_ir'');']);
    end   
    
    REF_sim = load('Sim_data\Med_dir\E_A0_02_M.MAT', 'pp_ir');
    
%     BB = conv(BB.pp_ir,REF_meas2);
%     REF_sim = conv(REF_sim,REF_meas2);
    
    % Delay % filter
    if plot_multi == 1
        if ii == 1       
            ir_sim_mat = zeros(2000, 10);
        end
        BB = conv(BB.pp_ir,REF_meas);
        TEST=BB;
        [~,locs3] = findpeaks(BB, 'SORTSTR', 'descend');    
        
        BB      = filter(Blp,1,[zeros(locs1(1),1); BB(locs3(1)-10:end)]); % Setter forsinkelse lik mledata,
        REF_sim = filter(Blp,1,[zeros(locs1(1),1); REF_sim.pp_ir]);       % og ptrykker et LP-filter
        
        ir_sim_mat(:,ii) = BB(1:2000);
    else
        BB      = [zeros(10,1); BB.pp_ir];      % Setter forsinkelse lik 10 samples
        REF_sim = [zeros(10,1); REF_sim.pp_ir];
    end
    

    
    % Ptrykker tidsvindu    
    win = win3;
%     B = BB(1:round(Fs2*0.0017));
    B = BB(1:round(Fs2*win(ii)));     
    REF_sim = REF_sim(1:round(Fs2*win(2)));
    
    % Filtrering
    if filtrer == 1
       B = filter(Blp,1,B);
       REF_sim = filter(Blp,1,REF_sim); 
    end

    % FFT
    L2 = length(B);
    NFFT2 = 2^(nextpow2(L2)+5);
    
    F3 = fft(B, NFFT2)/L2;
    F3 = F3(1:NFFT2/2+1).^2;
    
    F4 = fft(REF_sim, NFFT2)/L2;
    F4 = F4(1:NFFT2/2+1).^2;
    
    %% Smoothing
%     octfrac = 3;
%     fstart = 100;
%     fend = 19953;
%     npoints = 24;

    octfrac = 1;
    fstart = 121;
    fend = 15447;
    npoints = 8;
    
    fvec1 = Fs1/2*linspace(0,1,NFFT1/2+1);
    fvec2 = Fs2/2*linspace(0,1,NFFT2/2+1);
    
    [F1out,fvecout] = F2smospanew(fvec1,F1,octfrac,fstart,fend,npoints);
    [F2out]         = F2smospanew(fvec1,F2,octfrac,fstart,fend,npoints);
    [F3out]         = F2smospanew(fvec2,F3,octfrac,fstart,fend,npoints);
    [F4out]         = F2smospanew(fvec2,F4,octfrac,fstart,fend,npoints);
    
    % dB
    
    
    OFFSETT = 27.8;
    
    f1 = 10*log10(F1)-OFFSETT;
    f2 = 10*log10(F2)-OFFSETT;
    f3 = 10*log10(F3)-OFFSETT;
    f4 = 10*log10(F4)-OFFSETT;
    
    F1 = 10*log10(F1out)-OFFSETT;
    F2 = 10*log10(F2out)-OFFSETT;
    F3 = 10*log10(F3out)-OFFSETT;
    F4 = 10*log10(F4out)-OFFSETT;
    


    if ii == 1
        Diff1 = zeros(npoints, iii);

    end
    
    Diff1(:,ii) = F1 - (F3-F4+F2);
    
    %% Plot
    
    %% Freq
    if plot_freq == 1
        figure(2)
        semilogx(fvec1, f1, 'b')
        hold on
        semilogx(fvec1, f3-f4+f2, 'r')
        axis([100 5000 -20 1])
        grid on
        
        xlabel('Frekvens [Hz]')
        ylabel('Amplitude [dB]')

        JJ = num2str(ii/2);
        eval(['title(''Avstand - ',JJ,' m'')']);
        legend('Mling', 'CATT-simulering', 'location', 'NorthWest')
        hold off
        
        if filtrer == 1
           F1 = F1(1:14,1);
           F2 = F2(1:14,1);
           F3 = F3(1:14,1);
           F4 = F4(1:14,1);
           fvecout = fvecout(1:14,1);
        end
        
        figure(1)
        semilogx(fvecout(1:6,:), F1(1:6,:), '-ob')              % F1 = Mling
        hold on                                 % F2 = Ref. mling
%         semilogx(fvecout, F2, 'r')              % F3 = Sim.
        semilogx(fvecout(1:6,:), F3(1:6,:)-F4(1:6,:)+F2(1:6,:), '-or')        % F4 = Ref. sim.
        
        if ii == 1
            Diff_freq = zeros(npoints-10*filtrer,10);
        end
%         Diff_freq(:,ii) = F1-(F3-F4+F2);
%         semilogx(fvecout(1:6,:), Diff_freq(:,ii) + 50 , 'k')
        
%         semilogx(fvecout, F4+60, 'g')
%         hold on
%         semilogx(fvecout, F3+50, 'r')
        
        grid on
        hold off

%         axis([100 20000-18000*filtrer 20 100])
        axis([100 5000 -13.5 -4])
        xlabel('Frekvens [Hz]')
        ylabel('Amplitude [dB]')

        JJ = num2str(ii/2);
        eval(['title(''Avstand - ',JJ,' m'')']);

%         legend('Mling', 'Sim. - Ref. sim. + Ref. mling', 'Diff (Mling - Ref. mling) + 50dB', 'Location','SouthWest')
%         legend('Mling', 'Ref. mling', 'Sim. (Sim. - Ref. sim. + Ref. mling)', 'Diff (Mling - Sim.) + 60dB', 'Location','SouthWest')
        legend('Mling', 'CATT-simulering', 'location', 'NorthWest')
        if ii == 10
           figure(2)
           semilogx(fvecout, Diff_freq) 
           
           grid on      

           axis([100 20000-18000*filtrer -10 10])
           xlabel('Frekvens [Hz]')
           ylabel('Magnitude [dB]')
           
           str_legend = {'0.5 m', '1.0 m', '1.5 m', '2.0 m', '2.5 m', '3.0 m', '3.5 m', '4.0 m', '4.5 m', '5.0 m'};
           legend(str_legend, 'Location', 'NorthEastOutside')
           
           STD_freq = zeros(1,10);
           
           for jj = 1:10
               STD_freq(1,jj) = std(Diff_freq(:,jj));
           end
           
           figure(3)
           [AX,H1,H2] = plotyy([0.5:0.5:5], STD_freq,[0.5:0.5:5], win2.*1000);
           xlabel('Dist. [m]')
           ylabel(AX(1), 'STD [dB]')
           ylabel(AX(2), 'Window [ms]')
           set(H1,'Marker','o')
           set(H2,'Marker','o')
           
%            pause
        end
        pause 
    end
    
    %% IR Mlinger
    if plot_IR == 1
        
        figure(1)
        
        plot(1/48:1/48:length(AA(locs1-10:end))/48, AA(locs1-10:end))
        hold on
        plot(1/48:1/48:length(A)/48, A, 'r')
        ylim([-600 1150])
        
%         plot(BB(1:end))
%         hold on
%         plot(B, 'r')
%         ylim([-.1000 .1000])
legend('Forkastet', 'Benyttet')
        grid on
        hold off
        
%         xlim([0 800/48])
        xlim([0 12])

        xlabel('Tid [ms]')
        ylabel('Amplitude [ - ]')
        
        JJ = num2str(ii/2);
        commstr = ['title(''Avstand - ',JJ,''')'];
            eval(commstr); 
        
%         figure(2)
%         plot(REF_meas)
% 
%         grid on
%         hold off
% 
%         xlim([0 500])
%         xlabel('Frekvens [Hz]')
%         ylabel('Magnitude [dB]')
% 
%         JJ = num2str(ii/2);
%         commstr = ['title(''Avstand - ',JJ,''')'];
%             eval(commstr); 

        pause
    end
    
    %% Diff.: mlt vs mlt ref.
    if plot_diff == 1

        temp = mean(F1(1:124)) - mean(F2(1:124));

        if ii == 1
            Diff = zeros(1,10);
        end

        Diff(ii) = temp;   

        if ii == 10
            plot(0.5:0.5:5, Diff, '-o')   

            grid on

            title('Differanse: Mling vs. Ref. mling')
            xlabel('Avstand [m]')
            ylabel('Magnitude [dB]')

            pause
        end    
    end
end

if histogram == 1
    
    GSA_F1 = std(Diff1');
    
    GSA_D1 = std(Diff1);
    
    GSA_T1 = std(Diff1(:));
    
    
    figure(1)
    hist(Diff1')
            str_legend = { ...
         ['125 Hz (' num2str(round(GSA_F1(1,1)*10)/10) ')'], ...
         ['250 Hz (' num2str(round(GSA_F1(1,2)*10)/10) ')'], ... 
         ['500 Hz (' num2str(round(GSA_F1(1,3)*10)/10) ')'], ... 
        ['  1 kHz (' num2str(round(GSA_F1(1,4)*10)/10) ')'], ... 
        ['  2 kHz (' num2str(round(GSA_F1(1,5)*10)/10) ')'], ...
        ['  4 kHz (' num2str(round(GSA_F1(1,6)*10)/10) ')']};
    h = legend(str_legend, 'Location', 'NorthEast');
    v = get(h,'title');
    set(v,'string','Frekvens (GSA [dB])');
    title('CATT Akustikkhallen')
    xlabel('Avvik mellom simulering og mledata [dB]')
    ylabel('Antall')
    set(gca, 'YGrid', 'on') 
    
    figure(2)
    hist(Diff1)
    str_legend = { ...
        ['0.5 m (' num2str(round(GSA_D1(1,1)*10)/10) ')'], ...
        ['1.0 m (' num2str(round(GSA_D1(1,2)*10)/10) ')'], ... 
        ['1.5 m (' num2str(round(GSA_D1(1,3)*10)/10) ')'], ... 
        ['2.0 m (' num2str(round(GSA_D1(1,4)*10)/10) ')'], ... 
        ['2.5 m (' num2str(round(GSA_D1(1,5)*10)/10) ')'], ...
        ['3.0 m (' num2str(round(GSA_D1(1,2)*10)/10) ')'], ... 
        ['3.5 m (' num2str(round(GSA_D1(1,3)*10)/10) ')'], ... 
        ['4.0 m (' num2str(round(GSA_D1(1,4)*10)/10) ')'], ... 
        ['4.5 m (' num2str(round(GSA_D1(1,5)*10)/10) ')']};
    h = legend(str_legend, 'Location', 'NorthEast');
    v = get(h,'title');
    set(v,'string','Avstand (GSA [dB])');
    title('CATT Akustikkhallen')
    xlabel('Avvik mellom simulering og mledata [dB]')
    ylabel('Antall')
    set(gca, 'YGrid', 'on') 
    
    figure(3)
    hist(Diff1(:))
    str_legend = num2str(round(GSA_T1*100)/100);
    h = legend(str_legend, 'Location', 'NorthEast');
    v = get(h,'title');
    set(v,'string','GSA [dB]');
    title('CATT Akustikkhallen')
    xlabel('Avvik mellom simulering og mledata [dB]')
    ylabel('Antall')
    set(gca, 'YGrid', 'on') 
    
    pause
end

%% IR mlinger og sim.
if plot_multi == 1

    % Akust.
    plotshift = 500;
    plotmask = zeros(2000, 10);

    for ii = 2:10    
        plotmask(:, ii) = plotmask(:, ii) + plotshift*(ii-1);
    end

    figure(1)
    plot((1:length(ir_meas_mat))./48, ir_meas_mat + plotmask)

    % Sim.
    plotshift = 500;
    plotmask = zeros(2000, 10);
    title('Mlinger')
    xlabel('Tid [ms]')
    ylabel('Amplitude')
    xlim([0 40])

    for ii = 2:10    
        plotmask(:, ii) = plotmask(:, ii) + plotshift*(ii-1);
    end

    figure(2)
    plot((1:length(ir_sim_mat))./48, ir_sim_mat + plotmask*1)
    title('Simuleringer')
     xlabel('Tid [ms]')
    ylabel('Amplitude')
    xlim([0 40])
    
    pause
end

%% Lukk alt 
fopen('all');   % Lister alle pne filer
fclose('all');  % Lukker alle pne filer
close all       % Lukker alle plot